require 'fundler_spec_helper'

class TestBookmarksFundler
  describe Fundler do

    context 'bookmarks functions' do
      let(:fundler) { Fundler.new }
      before(:each) do
        FileUtils::mkdir 'test'
      end

      after(:each) do
        FileUtils::rm_rf 'test'
      end
      
      it 'drop txt bookmarks file' do
        FileUtils::cd './test' do
          fundler.bookmarks(:txt)
          expect(fundler.all_files).to include('bookmarks_dump.txt')
          file_line_count = File.foreach('bookmarks_dump.txt').inject(0) { |c, line| c+=1 }
          expect(fundler.bookmarks_count).to eq (file_line_count/2)
        end
      end

      it 'drop json bookmarks file' do
        FileUtils::cd './test' do
          fundler.bookmarks(:json)
          expect(fundler.all_files).to include('bookmarks_dump.json')
          file_line_count = File.foreach('bookmarks_dump.json').inject(0) { |c, line| c+=1 }
          expect(fundler.bookmarks_count).to eq (file_line_count)
        end
      end

      it 'get_bookmarks_with_tags' do
        expect { fundler.get_bookmarks_with_tags }.to_not raise_error
      end

      it 'get bookmarks url, title, descr and tag' do
        expect { fundler.get_bookmarks_with_url_title_descr_tag }.to_not raise_error
      end
    end # context

  end # describe
end # TestBookmarksFundler
